package models

type Star struct {
	Idx int
	X int
	Y int
	Richness int
	Owner int
	Ships int
	Turns int
	FlightsAllowed int
	Capturing bool
	CapturedBy int
}

type Flight struct {
	SourceStar int
	TargetStar int
	Ships int
	Owner int
	Turns int
}

type Link struct {
	SourceStar int
	TargetStar int
}

func (s *Star) Unowned() bool {
	return s.Owner < 0
}

func (s *Star) OwnedByMe() bool {
	return s.Owner == 0
}

func (s *Star) Friendly() bool {
	return s.Owner == 1
}

func (s *Star) Enemy() bool {
	return s.Owner == 2
}

func (s *Star) Captured() bool {
	return s.CapturedBy >= 0
}